import java.awt.*;
import java.applet.*;
import extras.TabbedPanel;

public class TabbedcolorBox extends Applet{
	Panel p1 = new Panel();
	Panel p2 = new Panel();
	Panel p3 = new Panel();
	Scrollbar cyansb = new Scrollbar(Scrollbar.VERTICAL,0,0,0,255);
	Scrollbar magentasb = new Scrollbar(Scrollbar.VERTICAL,0,0,0,255);
	Scrollbar yellowsb = new Scrollbar(Scrollbar.VERTICAL,0,0,0,255);
	Choice c = new Choice();
	colorBoxHelp hc = new colorBoxHelp(this);
	colorBox rgb = new colorBox();
	colorBox ycm = new colorBox();
	colorBox ycmv = new colorBox();
	TextField yellowTF, cyanTF, magentaTF;		
	
	public void init(){
		setBackground(Color.lightGray);
		setLayout(new BorderLayout());
		TabbedPanel tabs = new TabbedPanel();
		add("Center",tabs);
		getPanelp1();
		getPanelp2();
		getPanelp3();
		tabs.addItem("Help", hc);
		tabs.addItem("Mixing Light", p1);
		tabs.addItem("Mixing Pigments", p2);
		tabs.addItem("Color Printing",p3);
	}
	
	public void getPanelp1(){
		p1.setLayout(new BorderLayout());
		p1.add("Center", rgb);
	}
	
	public void getPanelp2(){
		ycm.additive = false;
		p2.setLayout(new BorderLayout());
		p2.add("Center", ycm);
	}
	
	public void getPanelp3() {
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints constraints = new GridBagConstraints();
		constraints.fill = GridBagConstraints.NONE;
		p3.setLayout(new BorderLayout());
		ycmv.additive = false;
		
		Panel p = new Panel();
		p.setLayout(gridbag);
		
		constraints.anchor = GridBagConstraints.SOUTH;
			
		buildConst(constraints,0,0,1,1,100,100);
		gridbag.setConstraints(yellowsb, constraints);
		p.add(yellowsb);
		
		yellowTF = new TextField("100",3);
		buildConst(constraints,1,0,1,1,100,100);
		gridbag.setConstraints(yellowTF, constraints);
		p.add(yellowTF);
		
		constraints.anchor = GridBagConstraints.NORTH;
		
		Label titleY = new Label("Yellow",Label.CENTER);
		titleY.setForeground(Color.yellow);
		titleY.setFont(new Font("times",Font.BOLD,14));
		buildConst(constraints,0,1,2,1,100,100);
		gridbag.setConstraints(titleY, constraints);
		p.add(titleY);
		
		constraints.anchor = GridBagConstraints.SOUTH;
		
		buildConst(constraints,0,2,1,1,100,100);
		gridbag.setConstraints(cyansb, constraints);
		p.add(cyansb);
		
		cyanTF = new TextField("100",3);
		buildConst(constraints,1,2,1,1,100,100);
		gridbag.setConstraints(cyanTF, constraints);
		p.add(cyanTF);
		
		constraints.anchor = GridBagConstraints.NORTH;
		
		Label titleC = new Label("Cyan",Label.CENTER);
		titleC.setForeground(Color.cyan);
		titleC.setFont(new Font("times",Font.BOLD,14));
		buildConst(constraints,0,3,2,1,100,100);
		gridbag.setConstraints(titleC, constraints);
		p.add(titleC);
		
		constraints.anchor = GridBagConstraints.SOUTH;
		
		buildConst(constraints,0,4,1,1,100,100);
		gridbag.setConstraints(magentasb, constraints);
		p.add(magentasb);
		
		magentaTF = new TextField("100",3);
		buildConst(constraints,1,4,1,1,100,100);
		gridbag.setConstraints(magentaTF, constraints);
		p.add(magentaTF);
		
		constraints.anchor = GridBagConstraints.NORTH;
		
		Label titleM = new Label("Magenta",Label.CENTER);
		titleM.setForeground(Color.magenta);
		titleM.setFont(new Font("times",Font.BOLD,14));
		buildConst(constraints,0,5,2,1,100,100);
		gridbag.setConstraints(titleM, constraints);
		p.add(titleM);
		
		c.addItem("Choose a color here!");
		c.addItem("Blue");
		c.addItem("Red");
		c.addItem("Green");
		c.addItem("Pink");
		c.addItem("Orange");
		c.addItem("Dark Brown");
		c.addItem("Coral");
		c.addItem("Turquoise");
		c.addItem("Yellow Green");
		c.addItem("Silver");
		c.select(0);
		
		p3.add("East",p);
		p3.add("South", c);
		p3.add("Center", ycmv);
	}	
	
	public synchronized boolean handleEvent(Event e) {
		int Yval, Cval, Mval;
		
		if (e.target instanceof Scrollbar) {
			if (e.target.equals(yellowsb)) {
				Yval = yellowsb.getValue();
				ycmv.Yellow = new Color(255,255,Yval);
				double inten = 100 - Yval/2.55;
				yellowTF.setText(String.valueOf((int)inten));
				ycmv.repaint();
			}
			if (e.target.equals(cyansb)) {
				Cval = cyansb.getValue();
				ycmv.Cyan = new Color(Cval,255,255);
				double inten = 100 - Cval/2.55;
				cyanTF.setText(String.valueOf((int)inten));
				ycmv.repaint();
			}
			if (e.target.equals(magentasb)) {
				Mval = magentasb.getValue();
				ycmv.Magenta = new Color(255,Mval,255);
				double inten = 100 - Mval/2.55;
				magentaTF.setText(String.valueOf((int)inten));
				ycmv.repaint();
			}	
		}
		
		if (e.target instanceof Choice) {
			int which = c.getSelectedIndex();
			
			ycmv.coordinate[0] = new Coordinate(135,105);
			ycmv.coordinate[1] = new Coordinate(140,100);
			ycmv.coordinate[2] = new Coordinate(145,105);
			ycmv.r1 = new Rect(ycmv.coordinate[0].x, ycmv.coordinate[0].y, ycmv.coordinate[0].x+ycmv.width, ycmv.coordinate[0].y+ycmv.width);
			ycmv.r2 = new Rect(ycmv.coordinate[1].x, ycmv.coordinate[1].y, ycmv.coordinate[1].x+ycmv.width, ycmv.coordinate[1].y+ycmv.width);
			ycmv.r3 = new Rect(ycmv.coordinate[2].x, ycmv.coordinate[2].y, ycmv.coordinate[2].x+ycmv.width, ycmv.coordinate[2].y+ycmv.width);
			ycmv.i12 = ycmv.r2.intersection(ycmv.r1);
			ycmv.i13 = ycmv.r3.intersection(ycmv.r1);
			ycmv.i23 = ycmv.r2.intersection(ycmv.r3);
			ycmv.i123 = ycmv.r1.intersection(ycmv.i23);
		
			if (which == 0) {
				yellowsb.setValue(0);
				magentasb.setValue(0);
				cyansb.setValue(0);
				ycmv.Yellow = new Color(255,255,0);
				yellowTF.setText(String.valueOf(100));
				ycmv.Magenta = new Color(255,0,255);
				magentaTF.setText(String.valueOf(100));
				ycmv.Cyan = new Color(0,255,255);
				cyanTF.setText(String.valueOf(100));
				ycmv.repaint();
			}	
			if (which == 1) {
				yellowsb.setValue(255);
				magentasb.setValue(0);
				cyansb.setValue(0);
				ycmv.Yellow = new Color(255,255,255);
				yellowTF.setText(String.valueOf(0));
				ycmv.Magenta = new Color(255,0,255);
				magentaTF.setText(String.valueOf(100));
				ycmv.Cyan = new Color(0,255,255);
				cyanTF.setText(String.valueOf(100));
				ycmv.repaint();
			}
			if (which == 2) {
				yellowsb.setValue(0);
				magentasb.setValue(0);
				cyansb.setValue(255);
				ycmv.Yellow = new Color(255,255,0);
				yellowTF.setText(String.valueOf(100));
				ycmv.Magenta = new Color(255,0,255);
				magentaTF.setText(String.valueOf(100));
				ycmv.Cyan = new Color(255,255,255);
				cyanTF.setText(String.valueOf(0));
				ycmv.repaint();
			}
			if (which == 3) {
				yellowsb.setValue(0);
				magentasb.setValue(255);
				cyansb.setValue(0);
				ycmv.Yellow = new Color(255,255,0);
				yellowTF.setText(String.valueOf(100));
				ycmv.Magenta = new Color(255,255,255);
				magentaTF.setText(String.valueOf(0));
				ycmv.Cyan = new Color(0,255,255);
				cyanTF.setText(String.valueOf(100));
				ycmv.repaint();	
			}
			if (which == 4) {
				yellowsb.setValue(175);
				magentasb.setValue(175);
				cyansb.setValue(255);
				ycmv.Yellow = new Color(255,255,175);
				yellowTF.setText(String.valueOf(31));
				ycmv.Magenta = new Color(255,175,255);
				magentaTF.setText(String.valueOf(31));
				ycmv.Cyan = new Color(255,255,255);
				cyanTF.setText(String.valueOf(0));
				ycmv.repaint();
			}
			if (which == 5) {
				yellowsb.setValue(0);
				magentasb.setValue(200);
				cyansb.setValue(255);
				ycmv.Yellow = new Color(255,255,0);
				yellowTF.setText(String.valueOf(100));
				ycmv.Magenta = new Color(255,200,255);
				magentaTF.setText(String.valueOf(21));
				ycmv.Cyan = new Color(255,255,255);
				cyanTF.setText(String.valueOf(0));
				ycmv.repaint();
			}
			if (which == 6) {
				yellowsb.setValue(23);
				magentasb.setValue(51);
				cyansb.setValue(92);
				ycmv.Yellow = new Color(255,255,23);
				yellowTF.setText(String.valueOf(91));
				ycmv.Magenta = new Color(255,51,255);
				magentaTF.setText(String.valueOf(80));
				ycmv.Cyan = new Color(92,255,255);
				cyanTF.setText(String.valueOf(64));
				ycmv.repaint();
			}
			if (which == 7) {
				yellowsb.setValue(0);
				magentasb.setValue(127);
				cyansb.setValue(255);
				ycmv.Yellow = new Color(255,255,0);
				yellowTF.setText(String.valueOf(100));
				ycmv.Magenta = new Color(255,127,255);
				magentaTF.setText(String.valueOf(50));
				ycmv.Cyan = new Color(255,255,255);
				cyanTF.setText(String.valueOf(0));
				ycmv.repaint();
			}
			if (which == 8) {
				yellowsb.setValue(234);
				magentasb.setValue(234);
				cyansb.setValue(173);
				ycmv.Yellow = new Color(255,255,234);
				yellowTF.setText(String.valueOf(8));
				ycmv.Magenta = new Color(255,234,255);
				magentaTF.setText(String.valueOf(8));
				ycmv.Cyan = new Color(173,255,255);
				cyanTF.setText(String.valueOf(32));
				ycmv.repaint();
			}if (which == 9) {
				yellowsb.setValue(50);
				magentasb.setValue(204);
				cyansb.setValue(153);
				ycmv.Yellow = new Color(255,255,50);
				yellowTF.setText(String.valueOf(80));
				ycmv.Magenta = new Color(255,204,255);
				magentaTF.setText(String.valueOf(20));
				ycmv.Cyan = new Color(153,255,255);
				cyanTF.setText(String.valueOf(40));
				ycmv.repaint();
			}if (which == 10) {
				yellowsb.setValue(250);
				magentasb.setValue(232);
				cyansb.setValue(230);
				ycmv.Yellow = new Color(255,255,250);
				yellowTF.setText(String.valueOf(2));
				ycmv.Magenta = new Color(255,232,255);
				magentaTF.setText(String.valueOf(9));
				ycmv.Cyan = new Color(230,255,255);
				cyanTF.setText(String.valueOf(9));
				ycmv.repaint();
			}
		}
		
		return super.handleEvent(e);
	}
	
	void buildConst(GridBagConstraints gbc, int gx, int gy, int gw, int gh, int wx, int wy){
		gbc.gridx = gx;
		gbc.gridy = gy;
		gbc.gridwidth = gw;
		gbc.gridheight = gh;
		gbc.weightx = wx;
		gbc.weighty = wy;
	}
	
	public Insets insets(){
		return new Insets(0,0,0,0);
	}
}